// C Source File
// Created 13/03/2003; 17:16:24

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

void addition (int x1, int x2, int *answer) {
	*answer = x1 + x2;
	x1 = 3;
	x2 = 5; // these variables are modified only within this procedure
}

void change (int *x, int *y, int *z) {
	int aux;
	
	aux = *x;
	*x = *y;
	*y = aux;
	*z = 27;
}


// Main Function

void _main(void)
{
	int a, b, c;
	int *sum;
	c = 13; /* you have to initialize also this variable or else when the code is running,
						 this variable haven't address */	
	sum = &c; // the pointer have to initialize for the same explication
	
	clrscr();

	a = 13;
	b = 4;
	addition (a, b, &c); // you want to give the address of your variable so you use '&'
	printf ("13 + 4 = %d\n", c);


	addition (17, 4, sum);/* you want to give the address of your pointer so you don't use 
													 //the '*' acronym, it's the definition of a pointer */
	printf ("\n\n17 + 4 = %d", *sum); 
	
	ngetchx();
	clrscr();
	
	printf ("initial value:\n a = %d\n b = %d\n c = %d", a , b, c);
	change (&a, &b, &c);
	/* the procedure gets the address of these variables and it modifies the data of these address
		 at the end of procedure, the address is available within the procedure and the out of the procedure */	
	printf ("\n\nfinal value:\n a = %d\n b = %d\n c = %d", a , b, c);
	
	ngetchx();
}
